//*********************************************************
//			o֐
//*********************************************************
#include "Gloval.h"

//*********************************************************
//	RXgN^
//*********************************************************
/*C_ObjBase :: C_ObjBase(){

	Speed	= 0;
	Angle	= 0;


}
*/

C_Base :: C_Base(){

	Back[0]			= LoadGraph( "img\\00.png" ) ;
	Back[1]			= LoadGraph( "img\\meikai.png" ) ;

	ScrollXSpeed	= 5;

	AllZero();

}


/*================================================================
	\̃[NA
================================================================*/
void C_Base :: ZeroClear(int num){

	C_ObjBase Zero	= {0};
	Tree[num]		= Zero;

}

/*================================================================
	G\̃I[NA
================================================================*/
void C_Base :: AllZero(){

	for( int i = 0 ; i < 100 ; i++ ){
		ZeroClear( i );
	}
}
//S
void C_Base :: ClossLine(){

	SetDrawBlendMode( DX_BLENDMODE_ALPHA, 255 );

/*	DrawLine( 0, CEN_Y, 640, CEN_Y, GetColor( 255, 255, 255 ) );
	DrawLine( CEN_X, 0, CEN_X, 480, GetColor( 255, 255, 255 ) );
	DrawCircle( CEN_X, CEN_Y, 5, GetColor( 255, 255, 255 ) );

	for( int i=0 ; i < 10 ; i++ ){
		int span	= 50*i;
		DrawLine( CEN_X -10, CEN_Y + span, CEN_X +10, CEN_Y + span, GetColor( 255, 255, 255 ) );
		DrawLine( CEN_X -10, CEN_Y - span, CEN_X +10, CEN_Y - span, GetColor( 255, 255, 255 ) );
		DrawLine( CEN_X + span, CEN_Y -10, CEN_X + span, CEN_Y +10, GetColor( 255, 255, 255 ) );
		DrawLine( CEN_X - span, CEN_Y -10, CEN_X - span, CEN_Y +10, GetColor( 255, 255, 255 ) );
	}

	*/

	DrawLine( 0, 0, MAX_X, MAX_Y, GetColor( 255, 255, 255 ) );
	DrawLine( 0, MAX_Y, MAX_X, 0, GetColor( 255, 255, 255 ) );


}
//`
void C_Base :: DrawSinCos(){

	DrawString( 0, 0, " sin cos ", GetColor( 255, 255, 255 ) );
	DrawFormatString( 0, 30, GetColor( 255, 255, 255 ), "%f", Angle );

	DrawCircle( (int)GetX(), (int)GetY(), 10, GetColor( 255, 255, 255 ) );

	SetX( (int)( CEN_X + cos( Angle * ( PI /180 ) )  *100 ) );
	SetY( (int)( CEN_Y + sin( Angle * ( PI /180 ) )  *100 ) );

	Angle	+= 2;

}


/*================================================================
	wi
================================================================*/
void C_Base :: DrawGround(){

	int AlphaBase	= 255;

	SetDrawBlendMode( DX_BLENDMODE_ALPHA, AlphaBase );
	SetDrawBright( AlphaBase, AlphaBase, AlphaBase );

	DrawGraph( 0, 0, Back[1], true );


	static int Count;
	if( Count >= 5 ){
		SetBloosom( Rand( CEN_X -150, CEN_X +150), CEN_Y +100);
		Count	=0;
	}
	Count++;

	ScallScroll( 0, 0, 0, Back[0], true );


}
/*================================================================
	zu
================================================================*/
void C_Base :: SetBloosom( int X, int Y ){

	for( int i=0 ; i < 100 ; i++ ){

		if( Tree[i].Flag == false ){
			Tree[i].Flag	= true;
			Tree[i].X		= X;
			Tree[i].Y		= Y;
			Tree[i].Scale	= 0.5;
			Tree[i].Alpha	= 0;

			break;
		}
	}

}

/*================================================================
	^3D
================================================================*/
void C_Base :: ScallScroll( int X, int Y, int Speed, int Image, bool Trans ){

	int count	=0;

	for( int i=0 ; i < 100 ; i++ ){

		if( Tree[i].Flag == true ){
			SetDrawBlendMode( DX_BLENDMODE_ALPHA, Tree[i].Alpha );
			DrawRotaGraph( (int)Tree[i].X, (int)Tree[i].Y, Tree[i].Scale, 0, Image, Trans, false );

			Tree[i].X		+= ( Tree[i].X - CEN_X ) /50;

			Tree[i].Y		+= 4;
			Tree[i].Scale	+= 0.01;

			if( Tree[i].Alpha < 255 ){
				Tree[i].Alpha	+= 3;
			}
			if( Tree[i].Scale >= 2 ){
				Tree[i].Flag	= false;
			}

			count++;
		}
	}

	SetDrawBlendMode( DX_BLENDMODE_ALPHA,255 );
	DrawFormatString(0, 0, 0xffffff, "%d", count );
}

/*================================================================
	[vXN[
================================================================*/
void C_Base :: LoopScroll( int X, int Y, int GrapX, int GrapY, int SizeX, int SizeY, int Image, int Speed, bool Trans ){

	DrawRectGraph( X, Y, AddX[Speed], GrapY, SizeX - AddX[Speed], SizeY, Image, Trans, false );
	DrawRectGraph( SizeX - AddX[Speed] + X, Y, GrapX, GrapY, AddX[Speed], SizeY, Image, Trans, false );

}

//*********************************************************
//	
//*********************************************************
int C_Base :: Rand( int Min, int Max ){
	
	if( Min < Max ){
		return	Min + GetRand( Max - Min );
	}
	else{
		return	0;
	}
}
double C_Base :: Rand( double Min, double Max ){
	
	if( Min < Max ){
		double CalMin	= Min *100;
		double CalMax	= Max *100;
	
		return	( CalMin + GetRand( (int)( CalMax - CalMin ) ) ) / 100;
	}
	else{
		return	0;
	}

}